<template>
	<div>
		<q-card class="cardPadding" bordered :style="generateStyle">
			<div
				v-if="roomSettings.roomNumber"
				class="text-center title"
			>{{ $t('room.roomLitteral') }}: {{this.roomId}}</div>

			<q-expansion-item
				default-opened
				expand-separator
				:label="$t('room.facilities')"
				v-if="room.facilities && roomSettings.facility"
				icon="home"
				:dense="roomSettings.dense"
			>
				<q-card-section class="full-width row wrap justify-center items-start content-center">
					<q-img
						class="icon"
						:src="facilitie.filename"
						v-for="facilitie in room.facilities"
						:key="facilitie.id"
					></q-img>
				</q-card-section>
			</q-expansion-item>
			<q-expansion-item
				default-opened
				expand-separator
				:label="$t('room.patient')"
				v-if="room.firstname && roomSettings.patient"
				icon="perm_identity"
				:dense="roomSettings.dense"
			>
				<div class="text-center">
					<img
						:style="getPictureStyle"
						v-if="room.patientPicture && roomSettings.patientPicture"
						:src="room.patientPicture"
					/>
				</div>
				<div class="text-center" style="padding: 4px;">
					{{ room.firstname }} {{ room.lastname }}&nbsp;
					<q-btn
						round
						size="xs"
						icon="edit"
						:dense="roomSettings.dense"
						@click="editingPatient = !editingPatient; modified = !modified;"
						color="primary"
					/>&nbsp;
					<q-btn
						round
						:dense="roomSettings.dense"
						size="xs"
						icon="details"
						@click="goToDetails(room)"
						color="primary"
					/>
				</div>
				<div class="text-center" v-if="(room.vegi || editingPatient) && roomSettings.vegi">
					{{ $t('room.vegi') }}&nbsp;
					<q-btn
						v-if="editingPatient && !room.vegi"
						round
						size="xs"
						icon="add"
						color="green"
						:dense="roomSettings.dense"
						@click="modified = true; room.vegi = true; room.vegan = false;"
					/>
					<q-btn
						v-if="editingPatient && room.vegi"
						round
						size="xs"
						icon="remove"
						color="red"
						:dense="roomSettings.dense"
						@click="modified = true; room.vegi = false;"
					/>
				</div>
				<div class="text-center" v-if="(room.vegan || editingPatient) && roomSettings.vegan">
					{{ $t('room.vegan') }}
					<q-btn
						v-if="editingPatient && !room.vegan"
						round
						size="xs"
						icon="add"
						color="green"
						:dense="roomSettings.dense"
						@click="modified = true; room.vegan = true; room.vegi = false;"
					/>
					<q-btn
						v-if="editingPatient && room.vegan"
						round
						size="xs"
						icon="remove"
						color="red"
						:dense="roomSettings.dense"
						@click="modified = true; room.vegan = false;"
					/>
				</div>
				<div v-if="isPatientInfo && roomSettings.patientIntake" style="padding: 2em;">
					<q-input
						autogrow
						v-model="room.reasonIntake"
						standout="bg-primary text-white"
						readonly
						v-if="$i18n.locale === 'en'"
						:dense="roomSettings.dense"
					/>
					<q-input
						autogrow
						v-model="room.redenOpname"
						standout="bg-primary text-white"
						readonly
						v-if="$i18n.locale === 'nl'"
						:dense="roomSettings.dense"
					/>
					<q-input
						autogrow
						v-model="room.dateIntake"
						standout="bg-primary text-white"
						readonly
						:dense="roomSettings.dense"
					/>
				</div>
			</q-expansion-item>
			<q-expansion-item
				default-opened
				expand-separator
				:label="$t('room.patientVitals')"
				icon="assessment"
				v-if="(room.heartRate || room.bp_upper || room.saturation || room.vegi || room.vegan) && roomSettings.vitals"
				:dense="roomSettings.dense"
			>
				<q-card-section class="text-center">
					<div
						v-if="room.heartRate && roomSettings.heartRate"
					>{{ $t('room.heartRate') }}: {{ room.heartRate }}</div>
					<div
						v-if="room.bp_upper && room.bp_lower && roomSettings.bp"
					>{{ $t('room.bp') }}: {{ room.bp_upper }}/{{ room.bp_lower }}</div>
					<div
						v-if="room.saturation && roomSettings.saturation"
					>{{ $t('room.saturation') }}: {{ room.saturation }}</div>
				</q-card-section>
			</q-expansion-item>
			<q-expansion-item
				default-opened
				expand-separator
				:label="$t('room.actions')"
				v-if="room.actions && roomSettings.actions"
				icon="schedule"
				:dense="roomSettings.dense"
			>
				<q-card-section>
					<q-card-section align="center">
						<q-btn
							round
							size="xs"
							icon="add"
							v-if="isDoctor"
							color="primary"
							class="bg-primary"
							@click="addActionprompt = true"
							:dense="roomSettings.dense"
						/>&nbsp;
						<q-btn
							round
							size="xs"
							icon="edit"
							@click="editingActions = !editingActions; modified = !modified;"
							color="primary"
							:dense="roomSettings.dense"
						/>
						<q-toggle
							:dense="roomSettings.dense"
							v-model="showCompleted"
							:label="$t('room.showCompleted')"
						/>
					</q-card-section>
					<q-card-section
						v-show="!action.done || (action.done && showCompleted)"
						v-for="action in room.actions"
						:key="action.id"
						class="bg-primary text-white"
						bordered
						:dense="roomSettings.dense"
					>
						<div>
							<q-btn
								v-if="editingActions"
								round
								size="xs"
								icon="delete_forever"
								color="red"
								:dense="roomSettings.dense"
								@click="modified = true; room.actions.splice( room.actions.indexOf(action), 1 );"
							/>
							<q-checkbox
								:dense="roomSettings.dense"
								color="green"
								v-model="action.done"
								@input="modified = true"
							/>
							{{calcTimeUntilAction(action.dateTime)}}
						</div>
						<div>
							<q-input
								autogrow
								v-model="action.name_nl"
								v-if="$i18n.locale === 'nl' && (!editingActions || !isDoctor) && isPatientInfo"
								standout="bg-primary text-white"
								readonly
								:dense="roomSettings.dense"
							/>
							<q-input
								autogrow
								v-model="action.name_en"
								v-if="$i18n.locale === 'en' && (!editingActions || !isDoctor) && isPatientInfo"
								standout="bg-primary text-white"
								readonly
								:dense="roomSettings.dense"
							/>

							<q-input
								autogrow
								v-model="action.description_nl"
								v-if="$i18n.locale === 'nl' && (!editingActions || !isDoctor)"
								standout="bg-primary text-white"
								readonly
								:dense="roomSettings.dense"
							/>
							<q-input
								autogrow
								v-model="action.description_en"
								v-if="$i18n.locale === 'en' && (!editingActions || !isDoctor)"
								standout="bg-primary text-white"
								readonly
								:dense="roomSettings.dense"
							/>
							<q-btn-dropdown
								:dense="roomSettings.dense"
								class="full-width bg-primary text-white"
								v-ripple
								v-if="editingActions && isDoctor"
							>
								<template v-slot:label>
									<span v-show="$i18n.locale === 'en' ">{{ action.name_en }}</span>
									<span v-show="$i18n.locale === 'nl'">{{ action.name_nl }}</span>
								</template>
								<q-list>
									<li v-for="act in actions" :key="act.id">
										<q-item
											clickable
											v-close-popup
											v-show="act.typeId != action.typeId"
											@click="action.typeId = act.id; action.name_en=act.name_en; action.name_nl=act.name_nl;"
										>
											<q-item-section>
												<q-item-label v-if="$i18n.locale === 'en'">{{act.name_en}}</q-item-label>
												<q-item-label v-if="$i18n.locale === 'nl'">{{act.name_nl}}</q-item-label>
											</q-item-section>
										</q-item>
									</li>
								</q-list>
							</q-btn-dropdown>
						</div>

						<q-input
							autogrow
							v-model="action.note"
							:dense="roomSettings.dense"
							standout="bg-primary text-white"
							:readonly="!editingActions || !isDoctor"
						/>
					</q-card-section>
				</q-card-section>
			</q-expansion-item>
		</q-card>
		<q-dialog v-model="addActionprompt" persistent maximized>
			<q-card style="min-width: 5em">
				<q-card-section dense class="row items-center bg-primary" style="height: 5em;">
					<div class="text-h6">{{$t('room.newAction')}}</div>
					<q-space />
					<q-btn icon="close" flat round dense v-close-popup />
				</q-card-section>
				<q-scroll-area style="height: calc(100% - 9em); margin-top:0em;">
					<q-card-section>
						<q-list dense>
							<q-item-label header>{{$t('selectType')}}:</q-item-label>
							<q-item dense>
								<q-btn-dropdown class="full-width bg-primary text-white" v-ripple>
									<template v-slot:label>
										<span v-show="newAction.typeId === ''">{{ $t('selectType') }}</span>
										<span
											v-show="$i18n.locale === 'en' && newAction.typeId !== ''"
										>{{ newAction.typeName_en }}</span>
										<span
											v-show="$i18n.locale === 'nl' && newAction.typeId !== ''"
										>{{ newAction.typeName_nl }}</span>
									</template>
									<q-list>
										<li v-for="act in actions" :key="act.id">
											<q-item
												clickable
												v-close-popup
												@click="newAction.typeId = act.id; newAction.typeName_en=act.name_en; newAction.typeName_nl=act.name_nl;"
											>
												<q-item-section>
													<q-item-label v-if="$i18n.locale === 'en'">{{act.name_en}}</q-item-label>
													<q-item-label v-if="$i18n.locale === 'nl'">{{act.name_nl}}</q-item-label>
												</q-item-section>
											</q-item>
										</li>
									</q-list>
								</q-btn-dropdown>
							</q-item>
							<q-item-label header>{{$t('dateTime')}}:</q-item-label>
							<q-item dense>
								<div class="q-gutter-md row items-start">
									<q-date bordered v-model="newAction.date" />
									<q-time format24h bordered v-model="newAction.time" />
								</div>
							</q-item>
							<q-item-label header>{{$t('note')}}:</q-item-label>
							<q-item dense>
								<q-input class="full-width" v-model="newAction.note" outlined clearable />
							</q-item>
						</q-list>
					</q-card-section>
				</q-scroll-area>

				<q-card-actions align="right" class="text-white absolute-bottom bg-primary">
					<q-btn flat :label="$t('cancel')" v-close-popup />
					<q-btn flat :label="$t('room.addAction')" v-close-popup @click="addAction" />
				</q-card-actions>
			</q-card>
		</q-dialog>
		<div v-if="soundAlarm && !forceMuteAlarm && roomSettings.alarm">
			<audio loop autoplay v-bind:volume="volume">
				<source src="http://localhost:3000/buzz.mp3" type="audio/mp3" />
				<!-- todo fix audo volume -->
			</audio>
		</div>
	</div>
</template>

<script>
	import { eventBus } from "../js/event.js";
	import fetchFn from "../js/fetch";

	let sleep = function(s) {
		return new Promise(resolve => setTimeout(resolve, s * 1000));
	};

	export default {
		name: "roomCard",
		data() {
			return {
				room: [],
				actions: [],
				APIURL: undefined,
				editingPatient: false,
				editingActions: false,
				soundAlarm: false,
				forceMuteAlarm: false,
				volume: 0.5,
				loadDataInterval: "",
				isDoctor: false,
				showCompleted: false,
				modified: false,
				modifierRunning: false,
				addActionprompt: false,
				newAction: {},
				roomSettings: {
					dense: false,
					roomNumber: true,
					facility: true,
					patient: true,
					patientPicture: true,
					patientIntake: true,
					vitals: true,
					actions: true,
					vegi: true,
					vegan: true,
					alarm: true,
					heartRate: true,
					hearRate_upper: 180,
					hearRate_lower: 50,
					bp: true,
					bp_upper_1: 200,
					bp_upper_2: 130,
					bp_lower_1: 100,
					bp_lower_2: 60,
					saturation: true,
					saturation_upper: 100,
					saturation_lower: 95,
					nextActionMinutes: 120
				}
			};
		},
		props: {
			roomId: {
				type: String,
				required: true
			},
			isPatientInfo: {
				type: Boolean,
				required: false,
				default: false
			}
		},
		created() {
			eventBus.$on("volumeChanged", vol => {
				this.volume = vol / 10;
			});
			this.clearNewAction();
			this.loadRoomData();
			this.asncOnCreated();

			// room UI settings
			if (this.$q.cookies.has("roomUISettings")) {
				this.roomSettings = this.$q.cookies.get("roomUISettings");
			}
			eventBus.$on("roomUISettings", token => {
				if (token) {
					this.roomSettings = this.$q.cookies.get("roomUISettings");
				}
			});

			this.APIURL = fetchFn.getAPIURL();

			this.loadDataInterval = setInterval(this.loadRoomData, 2000);
		},
		destroyed() {
			clearInterval(this.loadDataInterval);
		},
		computed: {
			getPictureStyle() {
				if (this.roomSettings.dense) {
					return `max-height: 7em; max-width: 40%; width: auto; height: auto;`;
				} else {
					return `max-height: 15em; max-width: 80%; width: auto; height: auto;`;
				}
			},
			generateStyle() {
				let style = "";
				if (this.room.firstname) {
					style = "background: green;";
				}
				if (this.room.actions) {
					let uncompletedActions = this.room.actions.filter(
						action => !action.done
					);

					if (uncompletedActions.length > 0) {
						let soonestActionDateTime = uncompletedActions[0].dateTime;

						let timeUntil = this.calcTimeUntilAction(
							soonestActionDateTime,
							"array"
						);
						let minutes =
							timeUntil[0] * 24 * 60 +
							timeUntil[1] * 60 +
							timeUntil[2];

						if (this.roomSettings.nextActionMinutes > minutes) {
							style = "background: #ffae00;";
						}
						if (timeUntil[0] === -1) {
							style = "background: #ff6600;";
						}
					}
				}
				if (this.room.calledForHelp === true) {
					style = "background: #ff0000;";
				}
				if (this.soundAlarm === true) {
					style =
						"background-color: #ff0000;animation-name: redPulse;animation-duration: 2s;animation-iteration-count: infinite;";
				}

				return style;
			}
		},
		methods: {
			calcTimeUntilAction(dateTime, mode = "normal") {
				let today = new Date();
				let date = new Date(dateTime);
				let diffMs = date - today;
				if (diffMs < 0) {
					if (mode === "normal") {
						return this.$i18n.t("error.timePassed");
					} else {
						return [-1, -1, -1];
					}
				}
				let diffDays = Math.floor(diffMs / 86400000);
				let diffHrs = Math.floor((diffMs % 86400000) / 3600000);
				let diffMins = Math.round(((diffMs % 86400000) % 3600000) / 60000);
				if (mode === "normal") {
					let string = "";
					if (diffDays > 0) {
						string =
							string +
							diffDays +
							" " +
							this.$i18n.t("time.days") +
							" ";
					}
					if (diffHrs > 0) {
						string =
							string +
							diffHrs +
							" " +
							this.$i18n.t("time.hours") +
							" ";
					}
					if (diffMins > 0) {
						string =
							string + diffMins + " " + this.$i18n.t("time.minutes");
					}
					return string;
				} else if (mode === "array") {
					return [diffDays, diffHrs, diffMins];
				}
			},
			async addAction() {
				if (this.newAction.typeId === "") {
					this.$alert(
						this.$i18n.t("error.typeNotGiven"),
						this.$i18n.t("error.error"),
						"error"
					);
					return;
				}

				this.modified = true;
				let count = this.room.actions.length + 1;
				if (count < 10) {
					this.newAction.id = "act00" + count;
				} else if (count < 100) {
					this.newAction.id = "act0" + count;
				} else {
					this.newAction.id = "act" + count;
				}
				let date = new Date();

				date.setHours(this.newAction.time.substring(0, 2));
				date.setMinutes(this.newAction.time.substring(3, 5));
				date.setDate(this.newAction.date.substring(8, 10));
				date.setMonth(this.newAction.date.substring(5, 7) - 1);
				date.setFullYear(this.newAction.date.substring(0, 4));

				this.newAction.dateTime = date;

				this.newAction.done = false;
				this.room.actions.push(this.newAction);
				this.clearNewAction();
				while (this.modifierRunning) {
					await sleep(0.5);
				}
				this.updateRoomData(this.room);
			},
			goToDetails(room) {
				this.$router.push({
					name: "patient",
					params: { id: room.patientId }
				});
			},
			clearNewAction() {
				this.newAction = {
					id: "",
					typeId: "",
					typeName_en: "",
					typeName_nl: "",
					date: "2020/01/01",
					time: "07:00",
					dateTime: "",
					done: undefined,
					note: ""
				};
			},
			async asncOnCreated() {
				this.actions = await fetchFn.getActions();
				try {
					this.isDoctor = await fetchFn.isDoctor(
						this.$q.cookies.get("loginToken")
					);
				} catch (e) {
					this.isDoctor = false;
				}
			},
			async updateRoomData(room) {
				if (this.modifierRunning === true) return;
				this.modifierRunning = true;
				try {
					let patient = await fetchFn.getPatientById(
						this.$q.cookies.get("loginToken"),
						room.patientId
					);

					if (room.actions.length !== patient.actions.length) {
						patient.actions = [];
						for (let i = 0; i < room.actions.length; i++) {
							patient.actions.push({
								id: "",
								typeId: "",
								dateTime: "",
								done: false,
								note: ""
							});
						}
					}

					for (let i = 0; i < patient.actions.length; i++) {
						const patientAction = patient.actions[i];
						const modifiedAction = room.actions[i];
						Object.keys(patientAction).forEach(key => {
							patientAction[key] = modifiedAction[key];
						});
					}

					patient["vegi"] = room.vegi;
					patient["vegan"] = room.vegan;

					await fetchFn.putPatient(patient);
					this.modified = this.editingPatient || this.editingActions;
				} catch (e) {
					this.$alert(
						this.$i18n.t("error.unexpected"),
						this.$i18n.t("error.error"),
						"error"
					);
				}
				this.modifierRunning = false;
			},
			async loadRoomData() {
				if (this.modified) {
					this.updateRoomData(this.room); // first update any changes to the actions
					return;
				}

				let tempRoom = await fetchFn.loadRoomData(
					this.$q.cookies.get("loginToken"),
					this.roomId
				);
				if (this.modified) return;

				tempRoom["patientPicture"] =
					this.APIURL + "/" + tempRoom["patientPicture"];

				if (tempRoom.actions) {
					for (let j = 0; j < tempRoom.actions.length; j++) {
						const roomAction = tempRoom.actions[j];

						for (let i = 0; i < this.actions.length; i++) {
							const toCombineAction = this.actions[i];
							if (roomAction.typeId === toCombineAction.id) {
								Object.keys(toCombineAction).forEach(key => {
									return (roomAction[key] = toCombineAction[key]);
								});
							}
						}
					}
					tempRoom.actions.sort((a, b) =>
						a.dateTime.localeCompare(b.dateTime)
					);
					tempRoom.actionsOriginal = {
						...tempRoom.actions,
						original: true
					};
				}

				if (tempRoom.facilities && this.APIURL) {
					for (let i = 0; i < tempRoom.facilities.length; i++) {
						const roomFacil = tempRoom.facilities[i];
						if (roomFacil) {
							const facilitie = await fetchFn.getFacilitie(
								roomFacil.id
							);

							Object.keys(facilitie).forEach(key => {
								if (key === "filename") {
									return (roomFacil[key] =
										this.APIURL + "/" + facilitie[key]);
								} else {
									return (roomFacil[key] = facilitie[key]);
								}
							});
						}
					}
				}

				if (this.modified) return;
				this.room = tempRoom;

				if (
					this.room.heartRate > this.roomSettings.hearRate_upper ||
					this.room.heartRate < this.roomSettings.hearRate_lower
				) {
					this.soundAlarm = true;
				} else if (
					this.room.bp_upper > this.roomSettings.bp_upper_1 ||
					this.room.bp_upper < this.roomSettings.bp_lower_1
				) {
					this.soundAlarm = true;
				} else if (
					this.room.bp_lower > this.roomSettings.bp_upper_2 ||
					this.room.bp_lower < this.roomSettings.bp_lower_2
				) {
					this.soundAlarm = true;
				} else if (
					this.room.saturation < this.roomSettings.saturation_lower ||
					this.room.saturation > this.roomSettings.saturation_upper
				) {
					this.soundAlarm = true;
				} else {
					this.soundAlarm = false;
				}
			}
		}
	};
</script>

<style>
	@keyframes redPulse {
		0% {
			background-color: #ff0000;
		}
		50% {
			background-color: #ff6600;
		}
		100% {
			background-color: #ff0000;
		}
	}
</style>

<style scoped>
	.cardPadding {
		padding-top: 0.5em;
	}
	.title {
		font-size: 2em;
	}
	.icon {
		max-width: 2em;
		max-height: 2em;
		overflow: auto;
		margin: 0 2px;
	}
</style>
